<?php

namespace CustomerManagement\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateCustomerInput StructType
 * @subpackage Structs
 */
class CreateCustomerInput extends AbstractStructBase
{
    /**
     * The InstallationTimeZone
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $InstallationTimeZone;
    /**
     * The Culture
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $Culture;
    /**
     * The PanelType
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $PanelType;
    /**
     * The PanelVersion
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $PanelVersion;
    /**
     * The panelSettingTemplateId
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $panelSettingTemplateId;
    /**
     * The PhoneLinePresent
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $PhoneLinePresent;
    /**
     * The CentralStationForwardingOption
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $CentralStationForwardingOption;
    /**
     * The PackageId
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $PackageId;
    /**
     * The IgnoreLowCoverageErrors
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IgnoreLowCoverageErrors;
    /**
     * The BranchId
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $BranchId;
    /**
     * The LeadId
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $LeadId;
    /**
     * The PropertyType
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $PropertyType;
    /**
     * The ContractEndDate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $ContractEndDate;
    /**
     * The EnrolledInMaintenance
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $EnrolledInMaintenance;
    /**
     * The PackageTemplateId
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $PackageTemplateId;
    /**
     * The CustomerAccountAddress
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \CustomerManagement\StructType\AddressWithName
     */
    public $CustomerAccountAddress;
    /**
     * The CustomerAccountEmail
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CustomerAccountEmail;
    /**
     * The CustomerAccountPhone
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CustomerAccountPhone;
    /**
     * The DealerCustomerId
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DealerCustomerId;
    /**
     * The DesiredLoginName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DesiredLoginName;
    /**
     * The DesiredPassword
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DesiredPassword;
    /**
     * The InstallationAddress
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \CustomerManagement\StructType\Address
     */
    public $InstallationAddress;
    /**
     * The ModemSerialNumber
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ModemSerialNumber;
    /**
     * The UnitDescription
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $UnitDescription;
    /**
     * The InstallerCode
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $InstallerCode;
    /**
     * The CsEventGroupsToForward
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \CustomerManagement\ArrayType\ArrayOfCentralStationEventGroupEnum
     */
    public $CsEventGroupsToForward;
    /**
     * The CentralStationAccountNumber
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CentralStationAccountNumber;
    /**
     * The CentralStationReceiverNumber
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CentralStationReceiverNumber;
    /**
     * The AddOnFeatures
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \CustomerManagement\ArrayType\ArrayOfAddOnFeatureEnum
     */
    public $AddOnFeatures;
    /**
     * The CustomerNotifications
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \CustomerManagement\ArrayType\ArrayOfCustomerNotificationEnum
     */
    public $CustomerNotifications;
    /**
     * The LoginNameAtAuthenticationProvider
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $LoginNameAtAuthenticationProvider;
    /**
     * The SalesRepLoginName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SalesRepLoginName;
    /**
     * The InstallerLoginName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $InstallerLoginName;
    /**
     * The ContractLengthInMonths
     * Meta informations extracted from the WSDL
     * - default: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $ContractLengthInMonths;
    /**
     * Constructor method for CreateCustomerInput
     * @uses CreateCustomerInput::setInstallationTimeZone()
     * @uses CreateCustomerInput::setCulture()
     * @uses CreateCustomerInput::setPanelType()
     * @uses CreateCustomerInput::setPanelVersion()
     * @uses CreateCustomerInput::setPanelSettingTemplateId()
     * @uses CreateCustomerInput::setPhoneLinePresent()
     * @uses CreateCustomerInput::setCentralStationForwardingOption()
     * @uses CreateCustomerInput::setPackageId()
     * @uses CreateCustomerInput::setIgnoreLowCoverageErrors()
     * @uses CreateCustomerInput::setBranchId()
     * @uses CreateCustomerInput::setLeadId()
     * @uses CreateCustomerInput::setPropertyType()
     * @uses CreateCustomerInput::setContractEndDate()
     * @uses CreateCustomerInput::setEnrolledInMaintenance()
     * @uses CreateCustomerInput::setPackageTemplateId()
     * @uses CreateCustomerInput::setCustomerAccountAddress()
     * @uses CreateCustomerInput::setCustomerAccountEmail()
     * @uses CreateCustomerInput::setCustomerAccountPhone()
     * @uses CreateCustomerInput::setDealerCustomerId()
     * @uses CreateCustomerInput::setDesiredLoginName()
     * @uses CreateCustomerInput::setDesiredPassword()
     * @uses CreateCustomerInput::setInstallationAddress()
     * @uses CreateCustomerInput::setModemSerialNumber()
     * @uses CreateCustomerInput::setUnitDescription()
     * @uses CreateCustomerInput::setInstallerCode()
     * @uses CreateCustomerInput::setCsEventGroupsToForward()
     * @uses CreateCustomerInput::setCentralStationAccountNumber()
     * @uses CreateCustomerInput::setCentralStationReceiverNumber()
     * @uses CreateCustomerInput::setAddOnFeatures()
     * @uses CreateCustomerInput::setCustomerNotifications()
     * @uses CreateCustomerInput::setLoginNameAtAuthenticationProvider()
     * @uses CreateCustomerInput::setSalesRepLoginName()
     * @uses CreateCustomerInput::setInstallerLoginName()
     * @uses CreateCustomerInput::setContractLengthInMonths()
     * @param string $installationTimeZone
     * @param string $culture
     * @param string $panelType
     * @param string $panelVersion
     * @param int $panelSettingTemplateId
     * @param bool $phoneLinePresent
     * @param string $centralStationForwardingOption
     * @param int $packageId
     * @param bool $ignoreLowCoverageErrors
     * @param int $branchId
     * @param int $leadId
     * @param string $propertyType
     * @param string $contractEndDate
     * @param bool $enrolledInMaintenance
     * @param int $packageTemplateId
     * @param \CustomerManagement\StructType\AddressWithName $customerAccountAddress
     * @param string $customerAccountEmail
     * @param string $customerAccountPhone
     * @param string $dealerCustomerId
     * @param string $desiredLoginName
     * @param string $desiredPassword
     * @param \CustomerManagement\StructType\Address $installationAddress
     * @param string $modemSerialNumber
     * @param string $unitDescription
     * @param string $installerCode
     * @param \CustomerManagement\ArrayType\ArrayOfCentralStationEventGroupEnum $csEventGroupsToForward
     * @param string $centralStationAccountNumber
     * @param string $centralStationReceiverNumber
     * @param \CustomerManagement\ArrayType\ArrayOfAddOnFeatureEnum $addOnFeatures
     * @param \CustomerManagement\ArrayType\ArrayOfCustomerNotificationEnum $customerNotifications
     * @param string $loginNameAtAuthenticationProvider
     * @param string $salesRepLoginName
     * @param string $installerLoginName
     * @param int $contractLengthInMonths
     */
    public function __construct($installationTimeZone = null, $culture = null, $panelType = null, $panelVersion = null, $panelSettingTemplateId = null, $phoneLinePresent = null, $centralStationForwardingOption = null, $packageId = null, $ignoreLowCoverageErrors = null, $branchId = null, $leadId = null, $propertyType = null, $contractEndDate = null, $enrolledInMaintenance = null, $packageTemplateId = null, \CustomerManagement\StructType\AddressWithName $customerAccountAddress = null, $customerAccountEmail = null, $customerAccountPhone = null, $dealerCustomerId = null, $desiredLoginName = null, $desiredPassword = null, \CustomerManagement\StructType\Address $installationAddress = null, $modemSerialNumber = null, $unitDescription = null, $installerCode = null, \CustomerManagement\ArrayType\ArrayOfCentralStationEventGroupEnum $csEventGroupsToForward = null, $centralStationAccountNumber = null, $centralStationReceiverNumber = null, \CustomerManagement\ArrayType\ArrayOfAddOnFeatureEnum $addOnFeatures = null, \CustomerManagement\ArrayType\ArrayOfCustomerNotificationEnum $customerNotifications = null, $loginNameAtAuthenticationProvider = null, $salesRepLoginName = null, $installerLoginName = null, $contractLengthInMonths = 0)
    {
        $this
            ->setInstallationTimeZone($installationTimeZone)
            ->setCulture($culture)
            ->setPanelType($panelType)
            ->setPanelVersion($panelVersion)
            ->setPanelSettingTemplateId($panelSettingTemplateId)
            ->setPhoneLinePresent($phoneLinePresent)
            ->setCentralStationForwardingOption($centralStationForwardingOption)
            ->setPackageId($packageId)
            ->setIgnoreLowCoverageErrors($ignoreLowCoverageErrors)
            ->setBranchId($branchId)
            ->setLeadId($leadId)
            ->setPropertyType($propertyType)
            ->setContractEndDate($contractEndDate)
            ->setEnrolledInMaintenance($enrolledInMaintenance)
            ->setPackageTemplateId($packageTemplateId)
            ->setCustomerAccountAddress($customerAccountAddress)
            ->setCustomerAccountEmail($customerAccountEmail)
            ->setCustomerAccountPhone($customerAccountPhone)
            ->setDealerCustomerId($dealerCustomerId)
            ->setDesiredLoginName($desiredLoginName)
            ->setDesiredPassword($desiredPassword)
            ->setInstallationAddress($installationAddress)
            ->setModemSerialNumber($modemSerialNumber)
            ->setUnitDescription($unitDescription)
            ->setInstallerCode($installerCode)
            ->setCsEventGroupsToForward($csEventGroupsToForward)
            ->setCentralStationAccountNumber($centralStationAccountNumber)
            ->setCentralStationReceiverNumber($centralStationReceiverNumber)
            ->setAddOnFeatures($addOnFeatures)
            ->setCustomerNotifications($customerNotifications)
            ->setLoginNameAtAuthenticationProvider($loginNameAtAuthenticationProvider)
            ->setSalesRepLoginName($salesRepLoginName)
            ->setInstallerLoginName($installerLoginName)
            ->setContractLengthInMonths($contractLengthInMonths);
    }
    /**
     * Get InstallationTimeZone value
     * @return string
     */
    public function getInstallationTimeZone()
    {
        return $this->InstallationTimeZone;
    }
    /**
     * Set InstallationTimeZone value
     * @uses \CustomerManagement\EnumType\TimeZoneEnum::valueIsValid()
     * @uses \CustomerManagement\EnumType\TimeZoneEnum::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $installationTimeZone
     * @return \CustomerManagement\StructType\CreateCustomerInput
     */
    public function setInstallationTimeZone($installationTimeZone = null)
    {
        // validation for constraint: enumeration
        if (!\CustomerManagement\EnumType\TimeZoneEnum::valueIsValid($installationTimeZone)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $installationTimeZone, implode(', ', \CustomerManagement\EnumType\TimeZoneEnum::getValidValues())), __LINE__);
        }
        $this->InstallationTimeZone = $installationTimeZone;
        return $this;
    }
    /**
     * Get Culture value
     * @return string
     */
    public function getCulture()
    {
        return $this->Culture;
    }
    /**
     * Set Culture value
     * @uses \CustomerManagement\EnumType\CultureEnum::valueIsValid()
     * @uses \CustomerManagement\EnumType\CultureEnum::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $culture
     * @return \CustomerManagement\StructType\CreateCustomerInput
     */
    public function setCulture($culture = null)
    {
        // validation for constraint: enumeration
        if (!\CustomerManagement\EnumType\CultureEnum::valueIsValid($culture)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $culture, implode(', ', \CustomerManagement\EnumType\CultureEnum::getValidValues())), __LINE__);
        }
        $this->Culture = $culture;
        return $this;
    }
    /**
     * Get PanelType value
     * @return string
     */
    public function getPanelType()
    {
        return $this->PanelType;
    }
    /**
     * Set PanelType value
     * @uses \CustomerManagement\EnumType\PanelTypeEnum::valueIsValid()
     * @uses \CustomerManagement\EnumType\PanelTypeEnum::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $panelType
     * @return \CustomerManagement\StructType\CreateCustomerInput
     */
    public function setPanelType($panelType = null)
    {
        // validation for constraint: enumeration
        if (!\CustomerManagement\EnumType\PanelTypeEnum::valueIsValid($panelType)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $panelType, implode(', ', \CustomerManagement\EnumType\PanelTypeEnum::getValidValues())), __LINE__);
        }
        $this->PanelType = $panelType;
        return $this;
    }
    /**
     * Get PanelVersion value
     * @return string
     */
    public function getPanelVersion()
    {
        return $this->PanelVersion;
    }
    /**
     * Set PanelVersion value
     * @uses \CustomerManagement\EnumType\PanelVersionEnum::valueIsValid()
     * @uses \CustomerManagement\EnumType\PanelVersionEnum::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $panelVersion
     * @return \CustomerManagement\StructType\CreateCustomerInput
     */
    public function setPanelVersion($panelVersion = null)
    {
        // validation for constraint: enumeration
        if (!\CustomerManagement\EnumType\PanelVersionEnum::valueIsValid($panelVersion)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $panelVersion, implode(', ', \CustomerManagement\EnumType\PanelVersionEnum::getValidValues())), __LINE__);
        }
        $this->PanelVersion = $panelVersion;
        return $this;
    }
    /**
     * Get panelSettingTemplateId value
     * @return int
     */
    public function getPanelSettingTemplateId()
    {
        return $this->panelSettingTemplateId;
    }
    /**
     * Set panelSettingTemplateId value
     * @param int $panelSettingTemplateId
     * @return \CustomerManagement\StructType\CreateCustomerInput
     */
    public function setPanelSettingTemplateId($panelSettingTemplateId = null)
    {
        // validation for constraint: int
        if (!is_null($panelSettingTemplateId) && !is_numeric($panelSettingTemplateId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($panelSettingTemplateId)), __LINE__);
        }
        $this->panelSettingTemplateId = $panelSettingTemplateId;
        return $this;
    }
    /**
     * Get PhoneLinePresent value
     * @return bool
     */
    public function getPhoneLinePresent()
    {
        return $this->PhoneLinePresent;
    }
    /**
     * Set PhoneLinePresent value
     * @param bool $phoneLinePresent
     * @return \CustomerManagement\StructType\CreateCustomerInput
     */
    public function setPhoneLinePresent($phoneLinePresent = null)
    {
        $this->PhoneLinePresent = $phoneLinePresent;
        return $this;
    }
    /**
     * Get CentralStationForwardingOption value
     * @return string
     */
    public function getCentralStationForwardingOption()
    {
        return $this->CentralStationForwardingOption;
    }
    /**
     * Set CentralStationForwardingOption value
     * @uses \CustomerManagement\EnumType\CentralStationForwardingOptionEnum::valueIsValid()
     * @uses \CustomerManagement\EnumType\CentralStationForwardingOptionEnum::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $centralStationForwardingOption
     * @return \CustomerManagement\StructType\CreateCustomerInput
     */
    public function setCentralStationForwardingOption($centralStationForwardingOption = null)
    {
        // validation for constraint: enumeration
        if (!\CustomerManagement\EnumType\CentralStationForwardingOptionEnum::valueIsValid($centralStationForwardingOption)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $centralStationForwardingOption, implode(', ', \CustomerManagement\EnumType\CentralStationForwardingOptionEnum::getValidValues())), __LINE__);
        }
        $this->CentralStationForwardingOption = $centralStationForwardingOption;
        return $this;
    }
    /**
     * Get PackageId value
     * @return int
     */
    public function getPackageId()
    {
        return $this->PackageId;
    }
    /**
     * Set PackageId value
     * @param int $packageId
     * @return \CustomerManagement\StructType\CreateCustomerInput
     */
    public function setPackageId($packageId = null)
    {
        // validation for constraint: int
        if (!is_null($packageId) && !is_numeric($packageId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($packageId)), __LINE__);
        }
        $this->PackageId = $packageId;
        return $this;
    }
    /**
     * Get IgnoreLowCoverageErrors value
     * @return bool
     */
    public function getIgnoreLowCoverageErrors()
    {
        return $this->IgnoreLowCoverageErrors;
    }
    /**
     * Set IgnoreLowCoverageErrors value
     * @param bool $ignoreLowCoverageErrors
     * @return \CustomerManagement\StructType\CreateCustomerInput
     */
    public function setIgnoreLowCoverageErrors($ignoreLowCoverageErrors = null)
    {
        $this->IgnoreLowCoverageErrors = $ignoreLowCoverageErrors;
        return $this;
    }
    /**
     * Get BranchId value
     * @return int
     */
    public function getBranchId()
    {
        return $this->BranchId;
    }
    /**
     * Set BranchId value
     * @param int $branchId
     * @return \CustomerManagement\StructType\CreateCustomerInput
     */
    public function setBranchId($branchId = null)
    {
        // validation for constraint: int
        if (!is_null($branchId) && !is_numeric($branchId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($branchId)), __LINE__);
        }
        $this->BranchId = $branchId;
        return $this;
    }
    /**
     * Get LeadId value
     * @return int
     */
    public function getLeadId()
    {
        return $this->LeadId;
    }
    /**
     * Set LeadId value
     * @param int $leadId
     * @return \CustomerManagement\StructType\CreateCustomerInput
     */
    public function setLeadId($leadId = null)
    {
        // validation for constraint: int
        if (!is_null($leadId) && !is_numeric($leadId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($leadId)), __LINE__);
        }
        $this->LeadId = $leadId;
        return $this;
    }
    /**
     * Get PropertyType value
     * @return string
     */
    public function getPropertyType()
    {
        return $this->PropertyType;
    }
    /**
     * Set PropertyType value
     * @uses \CustomerManagement\EnumType\PropertyTypeEnum::valueIsValid()
     * @uses \CustomerManagement\EnumType\PropertyTypeEnum::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $propertyType
     * @return \CustomerManagement\StructType\CreateCustomerInput
     */
    public function setPropertyType($propertyType = null)
    {
        // validation for constraint: enumeration
        if (!\CustomerManagement\EnumType\PropertyTypeEnum::valueIsValid($propertyType)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $propertyType, implode(', ', \CustomerManagement\EnumType\PropertyTypeEnum::getValidValues())), __LINE__);
        }
        $this->PropertyType = $propertyType;
        return $this;
    }
    /**
     * Get ContractEndDate value
     * @return string
     */
    public function getContractEndDate()
    {
        return $this->ContractEndDate;
    }
    /**
     * Set ContractEndDate value
     * @param string $contractEndDate
     * @return \CustomerManagement\StructType\CreateCustomerInput
     */
    public function setContractEndDate($contractEndDate = null)
    {
        // validation for constraint: string
        if (!is_null($contractEndDate) && !is_string($contractEndDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($contractEndDate)), __LINE__);
        }
        $this->ContractEndDate = $contractEndDate;
        return $this;
    }
    /**
     * Get EnrolledInMaintenance value
     * @return bool
     */
    public function getEnrolledInMaintenance()
    {
        return $this->EnrolledInMaintenance;
    }
    /**
     * Set EnrolledInMaintenance value
     * @param bool $enrolledInMaintenance
     * @return \CustomerManagement\StructType\CreateCustomerInput
     */
    public function setEnrolledInMaintenance($enrolledInMaintenance = null)
    {
        $this->EnrolledInMaintenance = $enrolledInMaintenance;
        return $this;
    }
    /**
     * Get PackageTemplateId value
     * @return int
     */
    public function getPackageTemplateId()
    {
        return $this->PackageTemplateId;
    }
    /**
     * Set PackageTemplateId value
     * @param int $packageTemplateId
     * @return \CustomerManagement\StructType\CreateCustomerInput
     */
    public function setPackageTemplateId($packageTemplateId = null)
    {
        // validation for constraint: int
        if (!is_null($packageTemplateId) && !is_numeric($packageTemplateId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($packageTemplateId)), __LINE__);
        }
        $this->PackageTemplateId = $packageTemplateId;
        return $this;
    }
    /**
     * Get CustomerAccountAddress value
     * @return \CustomerManagement\StructType\AddressWithName|null
     */
    public function getCustomerAccountAddress()
    {
        return $this->CustomerAccountAddress;
    }
    /**
     * Set CustomerAccountAddress value
     * @param \CustomerManagement\StructType\AddressWithName $customerAccountAddress
     * @return \CustomerManagement\StructType\CreateCustomerInput
     */
    public function setCustomerAccountAddress(\CustomerManagement\StructType\AddressWithName $customerAccountAddress = null)
    {
        $this->CustomerAccountAddress = $customerAccountAddress;
        return $this;
    }
    /**
     * Get CustomerAccountEmail value
     * @return string|null
     */
    public function getCustomerAccountEmail()
    {
        return $this->CustomerAccountEmail;
    }
    /**
     * Set CustomerAccountEmail value
     * @param string $customerAccountEmail
     * @return \CustomerManagement\StructType\CreateCustomerInput
     */
    public function setCustomerAccountEmail($customerAccountEmail = null)
    {
        // validation for constraint: string
        if (!is_null($customerAccountEmail) && !is_string($customerAccountEmail)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($customerAccountEmail)), __LINE__);
        }
        $this->CustomerAccountEmail = $customerAccountEmail;
        return $this;
    }
    /**
     * Get CustomerAccountPhone value
     * @return string|null
     */
    public function getCustomerAccountPhone()
    {
        return $this->CustomerAccountPhone;
    }
    /**
     * Set CustomerAccountPhone value
     * @param string $customerAccountPhone
     * @return \CustomerManagement\StructType\CreateCustomerInput
     */
    public function setCustomerAccountPhone($customerAccountPhone = null)
    {
        // validation for constraint: string
        if (!is_null($customerAccountPhone) && !is_string($customerAccountPhone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($customerAccountPhone)), __LINE__);
        }
        $this->CustomerAccountPhone = $customerAccountPhone;
        return $this;
    }
    /**
     * Get DealerCustomerId value
     * @return string|null
     */
    public function getDealerCustomerId()
    {
        return $this->DealerCustomerId;
    }
    /**
     * Set DealerCustomerId value
     * @param string $dealerCustomerId
     * @return \CustomerManagement\StructType\CreateCustomerInput
     */
    public function setDealerCustomerId($dealerCustomerId = null)
    {
        // validation for constraint: string
        if (!is_null($dealerCustomerId) && !is_string($dealerCustomerId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dealerCustomerId)), __LINE__);
        }
        $this->DealerCustomerId = $dealerCustomerId;
        return $this;
    }
    /**
     * Get DesiredLoginName value
     * @return string|null
     */
    public function getDesiredLoginName()
    {
        return $this->DesiredLoginName;
    }
    /**
     * Set DesiredLoginName value
     * @param string $desiredLoginName
     * @return \CustomerManagement\StructType\CreateCustomerInput
     */
    public function setDesiredLoginName($desiredLoginName = null)
    {
        // validation for constraint: string
        if (!is_null($desiredLoginName) && !is_string($desiredLoginName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($desiredLoginName)), __LINE__);
        }
        $this->DesiredLoginName = $desiredLoginName;
        return $this;
    }
    /**
     * Get DesiredPassword value
     * @return string|null
     */
    public function getDesiredPassword()
    {
        return $this->DesiredPassword;
    }
    /**
     * Set DesiredPassword value
     * @param string $desiredPassword
     * @return \CustomerManagement\StructType\CreateCustomerInput
     */
    public function setDesiredPassword($desiredPassword = null)
    {
        // validation for constraint: string
        if (!is_null($desiredPassword) && !is_string($desiredPassword)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($desiredPassword)), __LINE__);
        }
        $this->DesiredPassword = $desiredPassword;
        return $this;
    }
    /**
     * Get InstallationAddress value
     * @return \CustomerManagement\StructType\Address|null
     */
    public function getInstallationAddress()
    {
        return $this->InstallationAddress;
    }
    /**
     * Set InstallationAddress value
     * @param \CustomerManagement\StructType\Address $installationAddress
     * @return \CustomerManagement\StructType\CreateCustomerInput
     */
    public function setInstallationAddress(\CustomerManagement\StructType\Address $installationAddress = null)
    {
        $this->InstallationAddress = $installationAddress;
        return $this;
    }
    /**
     * Get ModemSerialNumber value
     * @return string|null
     */
    public function getModemSerialNumber()
    {
        return $this->ModemSerialNumber;
    }
    /**
     * Set ModemSerialNumber value
     * @param string $modemSerialNumber
     * @return \CustomerManagement\StructType\CreateCustomerInput
     */
    public function setModemSerialNumber($modemSerialNumber = null)
    {
        // validation for constraint: string
        if (!is_null($modemSerialNumber) && !is_string($modemSerialNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($modemSerialNumber)), __LINE__);
        }
        $this->ModemSerialNumber = $modemSerialNumber;
        return $this;
    }
    /**
     * Get UnitDescription value
     * @return string|null
     */
    public function getUnitDescription()
    {
        return $this->UnitDescription;
    }
    /**
     * Set UnitDescription value
     * @param string $unitDescription
     * @return \CustomerManagement\StructType\CreateCustomerInput
     */
    public function setUnitDescription($unitDescription = null)
    {
        // validation for constraint: string
        if (!is_null($unitDescription) && !is_string($unitDescription)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($unitDescription)), __LINE__);
        }
        $this->UnitDescription = $unitDescription;
        return $this;
    }
    /**
     * Get InstallerCode value
     * @return string|null
     */
    public function getInstallerCode()
    {
        return $this->InstallerCode;
    }
    /**
     * Set InstallerCode value
     * @param string $installerCode
     * @return \CustomerManagement\StructType\CreateCustomerInput
     */
    public function setInstallerCode($installerCode = null)
    {
        // validation for constraint: string
        if (!is_null($installerCode) && !is_string($installerCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($installerCode)), __LINE__);
        }
        $this->InstallerCode = $installerCode;
        return $this;
    }
    /**
     * Get CsEventGroupsToForward value
     * @return \CustomerManagement\ArrayType\ArrayOfCentralStationEventGroupEnum|null
     */
    public function getCsEventGroupsToForward()
    {
        return $this->CsEventGroupsToForward;
    }
    /**
     * Set CsEventGroupsToForward value
     * @param \CustomerManagement\ArrayType\ArrayOfCentralStationEventGroupEnum $csEventGroupsToForward
     * @return \CustomerManagement\StructType\CreateCustomerInput
     */
    public function setCsEventGroupsToForward(\CustomerManagement\ArrayType\ArrayOfCentralStationEventGroupEnum $csEventGroupsToForward = null)
    {
        $this->CsEventGroupsToForward = $csEventGroupsToForward;
        return $this;
    }
    /**
     * Get CentralStationAccountNumber value
     * @return string|null
     */
    public function getCentralStationAccountNumber()
    {
        return $this->CentralStationAccountNumber;
    }
    /**
     * Set CentralStationAccountNumber value
     * @param string $centralStationAccountNumber
     * @return \CustomerManagement\StructType\CreateCustomerInput
     */
    public function setCentralStationAccountNumber($centralStationAccountNumber = null)
    {
        // validation for constraint: string
        if (!is_null($centralStationAccountNumber) && !is_string($centralStationAccountNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($centralStationAccountNumber)), __LINE__);
        }
        $this->CentralStationAccountNumber = $centralStationAccountNumber;
        return $this;
    }
    /**
     * Get CentralStationReceiverNumber value
     * @return string|null
     */
    public function getCentralStationReceiverNumber()
    {
        return $this->CentralStationReceiverNumber;
    }
    /**
     * Set CentralStationReceiverNumber value
     * @param string $centralStationReceiverNumber
     * @return \CustomerManagement\StructType\CreateCustomerInput
     */
    public function setCentralStationReceiverNumber($centralStationReceiverNumber = null)
    {
        // validation for constraint: string
        if (!is_null($centralStationReceiverNumber) && !is_string($centralStationReceiverNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($centralStationReceiverNumber)), __LINE__);
        }
        $this->CentralStationReceiverNumber = $centralStationReceiverNumber;
        return $this;
    }
    /**
     * Get AddOnFeatures value
     * @return \CustomerManagement\ArrayType\ArrayOfAddOnFeatureEnum|null
     */
    public function getAddOnFeatures()
    {
        return $this->AddOnFeatures;
    }
    /**
     * Set AddOnFeatures value
     * @param \CustomerManagement\ArrayType\ArrayOfAddOnFeatureEnum $addOnFeatures
     * @return \CustomerManagement\StructType\CreateCustomerInput
     */
    public function setAddOnFeatures(\CustomerManagement\ArrayType\ArrayOfAddOnFeatureEnum $addOnFeatures = null)
    {
        $this->AddOnFeatures = $addOnFeatures;
        return $this;
    }
    /**
     * Get CustomerNotifications value
     * @return \CustomerManagement\ArrayType\ArrayOfCustomerNotificationEnum|null
     */
    public function getCustomerNotifications()
    {
        return $this->CustomerNotifications;
    }
    /**
     * Set CustomerNotifications value
     * @param \CustomerManagement\ArrayType\ArrayOfCustomerNotificationEnum $customerNotifications
     * @return \CustomerManagement\StructType\CreateCustomerInput
     */
    public function setCustomerNotifications(\CustomerManagement\ArrayType\ArrayOfCustomerNotificationEnum $customerNotifications = null)
    {
        $this->CustomerNotifications = $customerNotifications;
        return $this;
    }
    /**
     * Get LoginNameAtAuthenticationProvider value
     * @return string|null
     */
    public function getLoginNameAtAuthenticationProvider()
    {
        return $this->LoginNameAtAuthenticationProvider;
    }
    /**
     * Set LoginNameAtAuthenticationProvider value
     * @param string $loginNameAtAuthenticationProvider
     * @return \CustomerManagement\StructType\CreateCustomerInput
     */
    public function setLoginNameAtAuthenticationProvider($loginNameAtAuthenticationProvider = null)
    {
        // validation for constraint: string
        if (!is_null($loginNameAtAuthenticationProvider) && !is_string($loginNameAtAuthenticationProvider)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($loginNameAtAuthenticationProvider)), __LINE__);
        }
        $this->LoginNameAtAuthenticationProvider = $loginNameAtAuthenticationProvider;
        return $this;
    }
    /**
     * Get SalesRepLoginName value
     * @return string|null
     */
    public function getSalesRepLoginName()
    {
        return $this->SalesRepLoginName;
    }
    /**
     * Set SalesRepLoginName value
     * @param string $salesRepLoginName
     * @return \CustomerManagement\StructType\CreateCustomerInput
     */
    public function setSalesRepLoginName($salesRepLoginName = null)
    {
        // validation for constraint: string
        if (!is_null($salesRepLoginName) && !is_string($salesRepLoginName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($salesRepLoginName)), __LINE__);
        }
        $this->SalesRepLoginName = $salesRepLoginName;
        return $this;
    }
    /**
     * Get InstallerLoginName value
     * @return string|null
     */
    public function getInstallerLoginName()
    {
        return $this->InstallerLoginName;
    }
    /**
     * Set InstallerLoginName value
     * @param string $installerLoginName
     * @return \CustomerManagement\StructType\CreateCustomerInput
     */
    public function setInstallerLoginName($installerLoginName = null)
    {
        // validation for constraint: string
        if (!is_null($installerLoginName) && !is_string($installerLoginName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($installerLoginName)), __LINE__);
        }
        $this->InstallerLoginName = $installerLoginName;
        return $this;
    }
    /**
     * Get ContractLengthInMonths value
     * @return int|null
     */
    public function getContractLengthInMonths()
    {
        return $this->ContractLengthInMonths;
    }
    /**
     * Set ContractLengthInMonths value
     * @param int $contractLengthInMonths
     * @return \CustomerManagement\StructType\CreateCustomerInput
     */
    public function setContractLengthInMonths($contractLengthInMonths = 0)
    {
        // validation for constraint: int
        if (!is_null($contractLengthInMonths) && !is_numeric($contractLengthInMonths)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($contractLengthInMonths)), __LINE__);
        }
        $this->ContractLengthInMonths = $contractLengthInMonths;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \CustomerManagement\StructType\CreateCustomerInput
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
