<?php

namespace CustomerManagement\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SystemCheckOutput StructType
 * @subpackage Structs
 */
class SystemCheckOutput extends AbstractStructBase
{
    /**
     * The SystemCheckId
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $SystemCheckId;
    /**
     * The SystemCheckStartDate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $SystemCheckStartDate;
    /**
     * The SystemCheckEndDate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $SystemCheckEndDate;
    /**
     * The InitiatedRepId
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $InitiatedRepId;
    /**
     * The InitiatedLoginId
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $InitiatedLoginId;
    /**
     * The IsRunning
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsRunning;
    /**
     * The TestCategories
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \CustomerManagement\ArrayType\ArrayOfSystemCheckCategoryOutput
     */
    public $TestCategories;
    /**
     * Constructor method for SystemCheckOutput
     * @uses SystemCheckOutput::setSystemCheckId()
     * @uses SystemCheckOutput::setSystemCheckStartDate()
     * @uses SystemCheckOutput::setSystemCheckEndDate()
     * @uses SystemCheckOutput::setInitiatedRepId()
     * @uses SystemCheckOutput::setInitiatedLoginId()
     * @uses SystemCheckOutput::setIsRunning()
     * @uses SystemCheckOutput::setTestCategories()
     * @param int $systemCheckId
     * @param string $systemCheckStartDate
     * @param string $systemCheckEndDate
     * @param int $initiatedRepId
     * @param int $initiatedLoginId
     * @param bool $isRunning
     * @param \CustomerManagement\ArrayType\ArrayOfSystemCheckCategoryOutput $testCategories
     */
    public function __construct($systemCheckId = null, $systemCheckStartDate = null, $systemCheckEndDate = null, $initiatedRepId = null, $initiatedLoginId = null, $isRunning = null, \CustomerManagement\ArrayType\ArrayOfSystemCheckCategoryOutput $testCategories = null)
    {
        $this
            ->setSystemCheckId($systemCheckId)
            ->setSystemCheckStartDate($systemCheckStartDate)
            ->setSystemCheckEndDate($systemCheckEndDate)
            ->setInitiatedRepId($initiatedRepId)
            ->setInitiatedLoginId($initiatedLoginId)
            ->setIsRunning($isRunning)
            ->setTestCategories($testCategories);
    }
    /**
     * Get SystemCheckId value
     * @return int
     */
    public function getSystemCheckId()
    {
        return $this->SystemCheckId;
    }
    /**
     * Set SystemCheckId value
     * @param int $systemCheckId
     * @return \CustomerManagement\StructType\SystemCheckOutput
     */
    public function setSystemCheckId($systemCheckId = null)
    {
        // validation for constraint: int
        if (!is_null($systemCheckId) && !is_numeric($systemCheckId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($systemCheckId)), __LINE__);
        }
        $this->SystemCheckId = $systemCheckId;
        return $this;
    }
    /**
     * Get SystemCheckStartDate value
     * @return string
     */
    public function getSystemCheckStartDate()
    {
        return $this->SystemCheckStartDate;
    }
    /**
     * Set SystemCheckStartDate value
     * @param string $systemCheckStartDate
     * @return \CustomerManagement\StructType\SystemCheckOutput
     */
    public function setSystemCheckStartDate($systemCheckStartDate = null)
    {
        // validation for constraint: string
        if (!is_null($systemCheckStartDate) && !is_string($systemCheckStartDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($systemCheckStartDate)), __LINE__);
        }
        $this->SystemCheckStartDate = $systemCheckStartDate;
        return $this;
    }
    /**
     * Get SystemCheckEndDate value
     * @return string
     */
    public function getSystemCheckEndDate()
    {
        return $this->SystemCheckEndDate;
    }
    /**
     * Set SystemCheckEndDate value
     * @param string $systemCheckEndDate
     * @return \CustomerManagement\StructType\SystemCheckOutput
     */
    public function setSystemCheckEndDate($systemCheckEndDate = null)
    {
        // validation for constraint: string
        if (!is_null($systemCheckEndDate) && !is_string($systemCheckEndDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($systemCheckEndDate)), __LINE__);
        }
        $this->SystemCheckEndDate = $systemCheckEndDate;
        return $this;
    }
    /**
     * Get InitiatedRepId value
     * @return int
     */
    public function getInitiatedRepId()
    {
        return $this->InitiatedRepId;
    }
    /**
     * Set InitiatedRepId value
     * @param int $initiatedRepId
     * @return \CustomerManagement\StructType\SystemCheckOutput
     */
    public function setInitiatedRepId($initiatedRepId = null)
    {
        // validation for constraint: int
        if (!is_null($initiatedRepId) && !is_numeric($initiatedRepId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($initiatedRepId)), __LINE__);
        }
        $this->InitiatedRepId = $initiatedRepId;
        return $this;
    }
    /**
     * Get InitiatedLoginId value
     * @return int
     */
    public function getInitiatedLoginId()
    {
        return $this->InitiatedLoginId;
    }
    /**
     * Set InitiatedLoginId value
     * @param int $initiatedLoginId
     * @return \CustomerManagement\StructType\SystemCheckOutput
     */
    public function setInitiatedLoginId($initiatedLoginId = null)
    {
        // validation for constraint: int
        if (!is_null($initiatedLoginId) && !is_numeric($initiatedLoginId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($initiatedLoginId)), __LINE__);
        }
        $this->InitiatedLoginId = $initiatedLoginId;
        return $this;
    }
    /**
     * Get IsRunning value
     * @return bool
     */
    public function getIsRunning()
    {
        return $this->IsRunning;
    }
    /**
     * Set IsRunning value
     * @param bool $isRunning
     * @return \CustomerManagement\StructType\SystemCheckOutput
     */
    public function setIsRunning($isRunning = null)
    {
        $this->IsRunning = $isRunning;
        return $this;
    }
    /**
     * Get TestCategories value
     * @return \CustomerManagement\ArrayType\ArrayOfSystemCheckCategoryOutput|null
     */
    public function getTestCategories()
    {
        return $this->TestCategories;
    }
    /**
     * Set TestCategories value
     * @param \CustomerManagement\ArrayType\ArrayOfSystemCheckCategoryOutput $testCategories
     * @return \CustomerManagement\StructType\SystemCheckOutput
     */
    public function setTestCategories(\CustomerManagement\ArrayType\ArrayOfSystemCheckCategoryOutput $testCategories = null)
    {
        $this->TestCategories = $testCategories;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \CustomerManagement\StructType\SystemCheckOutput
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
